searchNodes=[{"doc":"Top level types and convenience functions. This module holds some top-level types and a convenience function for creating a new schedule. Details available in the Cocktail.Schedule module.","ref":"Cocktail.html","title":"Cocktail","type":"module"},{"doc":"Creates a new schedule using the given start time and options. see Cocktail.Schedule.new/1 for details.","ref":"Cocktail.html#schedule/2","title":"Cocktail.schedule/2","type":"function"},{"doc":"","ref":"Cocktail.html#t:day/0","title":"Cocktail.day/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:day_atom/0","title":"Cocktail.day_atom/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:day_number/0","title":"Cocktail.day_number/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:day_of_month/0","title":"Cocktail.day_of_month/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:frequency/0","title":"Cocktail.frequency/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:hour_number/0","title":"Cocktail.hour_number/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:minute_number/0","title":"Cocktail.minute_number/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:occurrence/0","title":"Cocktail.occurrence/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:rule_option/0","title":"Cocktail.rule_option/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:rule_options/0","title":"Cocktail.rule_options/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:schedule_option/0","title":"Cocktail.schedule_option/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:schedule_options/0","title":"Cocktail.schedule_options/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:second_number/0","title":"Cocktail.second_number/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:time/0","title":"Cocktail.time/0","type":"type"},{"doc":"","ref":"Cocktail.html#t:time_range/0","title":"Cocktail.time_range/0","type":"type"},{"doc":"Build iCalendar format strings from schedules. TODO: write long description","ref":"Cocktail.Builder.ICalendar.html","title":"Cocktail.Builder.ICalendar","type":"module"},{"doc":"Builds an iCalendar format string representation of a Cocktail.Schedule.t/0 . Examples iex&gt; alias Cocktail.Schedule ...&gt; start_time = Timex . to_datetime ( ~N[2017-01-01 06:00:00] , &quot;America/Los_Angeles&quot; ) ...&gt; schedule = Schedule . new ( start_time ) ...&gt; schedule = Schedule . add_recurrence_rule ( schedule , :daily , interval : 2 , hours : [ 10 , 12 ] ) ...&gt; build ( schedule ) &quot;DTSTART;TZID=America/Los_Angeles:20170101T060000 \\n RRULE:FREQ=DAILY;INTERVAL=2;BYHOUR=10,12&quot; iex&gt; alias Cocktail.Schedule ...&gt; schedule = Schedule . new ( ~N[2017-01-01 06:00:00] ) ...&gt; schedule = Schedule . add_recurrence_rule ( schedule , :daily , until : ~N[2017-01-31 11:59:59] ) ...&gt; build ( schedule ) &quot;DTSTART:20170101T060000 \\n RRULE:FREQ=DAILY;UNTIL=20170131T115959&quot; iex&gt; alias Cocktail.Schedule ...&gt; schedule = Schedule . new ( ~N[2017-01-01 06:00:00] ) ...&gt; schedule = Schedule . add_recurrence_rule ( schedule , :daily , count : 3 ) ...&gt; build ( schedule ) &quot;DTSTART:20170101T060000 \\n RRULE:FREQ=DAILY;COUNT=3&quot;","ref":"Cocktail.Builder.ICalendar.html#build/1","title":"Cocktail.Builder.ICalendar.build/1","type":"function"},{"doc":"Builds an iCalendar RRULE format string representation of a Cocktail.Schedule.t/0 Examples iex&gt; alias Cocktail.Schedule ...&gt; start_time = Timex . to_datetime ( ~N[2017-01-01 06:00:00] , &quot;America/Los_Angeles&quot; ) ...&gt; schedule = Schedule . new ( start_time ) ...&gt; schedule = Schedule . add_recurrence_rule ( schedule , :daily , interval : 2 , hours : [ 10 , 12 ] ) ...&gt; build_rule ( schedule ) &quot;RRULE:FREQ=DAILY;INTERVAL=2;BYHOUR=10,12&quot; iex&gt; alias Cocktail.Schedule ...&gt; schedule = Schedule . new ( ~N[2017-01-01 06:00:00] ) ...&gt; schedule = Schedule . add_recurrence_rule ( schedule , :daily , until : ~N[2017-01-31 11:59:59] ) ...&gt; build_rule ( schedule ) &quot;RRULE:FREQ=DAILY;UNTIL=20170131T115959&quot; iex&gt; alias Cocktail.Schedule ...&gt; schedule = Schedule . new ( ~N[2017-01-01 06:00:00] ) ...&gt; schedule = Schedule . add_recurrence_rule ( schedule , :daily , count : 3 ) ...&gt; build_rule ( schedule ) &quot;RRULE:FREQ=DAILY;COUNT=3&quot;","ref":"Cocktail.Builder.ICalendar.html#build_rule/1","title":"Cocktail.Builder.ICalendar.build_rule/1","type":"function"},{"doc":"Build human readable strings from schedules. This module exposes functions for building human readable string representations of schedules. It currently only represents the recurrence rules of a schedule, and doesn't indicate the start time, duration, nor any recurrence times or exception times. This is mainly useful for quick glances at schedules in IEx sessions (because it's used for the inspect implementation) and for simple doctests.","ref":"Cocktail.Builder.String.html","title":"Cocktail.Builder.String","type":"module"},{"doc":"Builds a human readable string representation of a Cocktail.Schedule.t/0 . Examples iex&gt; alias Cocktail.Schedule ...&gt; schedule = Schedule . new ( ~N[2017-01-01 06:00:00] ) ...&gt; schedule = Schedule . add_recurrence_rule ( schedule , :daily , interval : 2 , hours : [ 10 , 12 ] ) ...&gt; build ( schedule ) &quot;Every 2 days on the 10th and 12th hours of the day&quot;","ref":"Cocktail.Builder.String.html#build/1","title":"Cocktail.Builder.String.build/1","type":"function"},{"doc":"Create schedules from iCalendar format. TODO: write long description","ref":"Cocktail.Parser.ICalendar.html","title":"Cocktail.Parser.ICalendar","type":"module"},{"doc":"Parses a string in iCalendar format into a Cocktail.Schedule.t/0 . Examples iex&gt; { :ok , schedule } = parse ( &quot;DTSTART;TZID=America/Los_Angeles:20170810T160000 \\n RRULE:FREQ=DAILY;INTERVAL=2&quot; ) ...&gt; schedule # Cocktail.Schedule &lt; Every 2 days &gt; iex&gt; { :ok , schedule } = parse ( &quot;DTSTART;TZID=America/Los_Angeles:20170810T160000 \\n RRULE:FREQ=WEEKLY&quot; ) ...&gt; schedule # Cocktail.Schedule &lt; Weekly &gt; iex&gt; { :ok , schedule } = parse ( &quot;DTSTART;TZID=America/Los_Angeles:20170810T160000 \\n RRULE:FREQ=WEEKLY;BYDAY=MO,WE,FR&quot; ) ...&gt; schedule # Cocktail.Schedule &lt; Weekly on Mondays , Wednesdays and Fridays &gt; iex&gt; { :ok , schedule } = parse ( &quot;DTSTART;TZID=America/Los_Angeles:20170810T160000 \\n RRULE:FREQ=WEEKLY;INTERVAL=2;BYDAY=MO,WE,FR;BYHOUR=10,12,14&quot; ) ...&gt; schedule # Cocktail.Schedule &lt; Every 2 weeks on Mondays , Wednesdays and Fridays on the 10 th , 12 th and 14 th hours of the day &gt;","ref":"Cocktail.Parser.ICalendar.html#parse/1","title":"Cocktail.Parser.ICalendar.parse/1","type":"function"},{"doc":"Represent a recurrence rule (RRULE).","ref":"Cocktail.Rule.html","title":"Cocktail.Rule","type":"module"},{"doc":"","ref":"Cocktail.Rule.html#new/1","title":"Cocktail.Rule.new/1","type":"function"},{"doc":"","ref":"Cocktail.Rule.html#set_until/2","title":"Cocktail.Rule.set_until/2","type":"function"},{"doc":"","ref":"Cocktail.Rule.html#t:t/0","title":"Cocktail.Rule.t/0","type":"type"},{"doc":"Struct used to represent a schedule of recurring events. Use the new/2 function to create a new schedule, and the add_recurrence_rule/2 function to add rules to describe how to repeat. Currently, Cocktail supports the following types of repeat rules: Weekly - Every week, relative to the schedule's start time Daily - Every day at the schedule's start time Hourly - Every hour, starting at the schedule's start time Minutely - Every minute, starting at the schedule's start time Secondly - Every second, starting at the schedule's start time Once a schedule has been created, you can use occurrences/2 to generate a stream of occurrences, which are either Cocktail.time/0 s or Cocktail.Span.t/0 s if a duration option was given to the schedule. Various options can be given to modify the way the repeat rule and schedule behave. See add_recurrence_rule/3 for details on them.","ref":"Cocktail.Schedule.html","title":"Cocktail.Schedule","type":"module"},{"doc":"Adds an exception time to the schedule. This exception time will cancel out any occurrence generated from the schedule's recurrence rules or recurrence times.","ref":"Cocktail.Schedule.html#add_exception_time/2","title":"Cocktail.Schedule.add_exception_time/2","type":"function"},{"doc":"Adds a recurrence rule of the given frequency to a schedule. The frequency can be one of :monthly , :weekly , :daily , :hourly , :minutely or :secondly Options :interval - How often to repeat, given the frequency. For example a :daily rule with interval 2 would be &quot;every other day&quot;. :count - The number of times this rule can produce an occurrence. (not yet support) :until - The end date/time after which the rule will no longer produce occurrences. :days_of_month - Restrict this rule to specific days of the month. (e.g. [-1, 10, 31] ) :days - Restrict this rule to specific days. (e.g. [:monday, :wednesday, :friday] ) :hours - Restrict this rule to certain hours of the day. (e.g. [10, 12, 14] ) :minutes - Restrict this rule to certain minutes of the hour. (e.g. [0, 15, 30, 45] ) :seconds - Restrict this rule to certain seconds of the minute. (e.g. [0, 30] ) Examples iex&gt; start_time = ~N[2017-01-01 06:00:00] ...&gt; start_time |&gt; new ( ) |&gt; add_recurrence_rule ( :daily , interval : 2 , hours : [ 10 , 14 ] ) # Cocktail.Schedule &lt; Every 2 days on the 10 th and 14 th hours of the day &gt;","ref":"Cocktail.Schedule.html#add_recurrence_rule/3","title":"Cocktail.Schedule.add_recurrence_rule/3","type":"function"},{"doc":"Adds a one-off recurrence time to the schedule. This recurrence time can be any time after (or including) the schedule's start time. When generating occurrences from this schedule, the given time will be included in the set of occurrences alongside any recurrence rules.","ref":"Cocktail.Schedule.html#add_recurrence_time/2","title":"Cocktail.Schedule.add_recurrence_time/2","type":"function"},{"doc":"Add an end time to all recurrence rules in the schedule. This has the same effect as if you'd passed the :until option when adding all recurrence rules to the schedule.","ref":"Cocktail.Schedule.html#end_all_recurrence_rules/2","title":"Cocktail.Schedule.end_all_recurrence_rules/2","type":"function"},{"doc":"Parses a string in iCalendar format into a Cocktail.Schedule.t/0 . see Cocktail.Parser.ICalendar.parse/1 for details.","ref":"Cocktail.Schedule.html#from_i_calendar/1","title":"Cocktail.Schedule.from_i_calendar/1","type":"function"},{"doc":"Creates a new schedule using the given start time and options. This schedule will be empty and needs recurrence rules added to it before it is useful. Use add_recurrence_rule/3 to add rules to a schedule. Options :duration - The duration of each event in the schedule (in seconds). Examples iex&gt; new ( ~N[2017-01-01 06:00:00] , duration : 3_600 ) # Cocktail.Schedule &lt; &gt;","ref":"Cocktail.Schedule.html#new/2","title":"Cocktail.Schedule.new/2","type":"function"},{"doc":"Creates a stream of occurrences from the given schedule. An optional start_time can be supplied to not start at the schedule's start time. The occurrences that are produced by the stream can be one of several types: If the schedule's start time is a DateTime.t/0 , then it will produce DateTime.t/0 s If the schedule's start time is a NaiveDateTime.t/0 , the it will produce NaiveDateTime.t/0 s If a duration is supplied when creating the schedule, the stream will produce Cocktail.Span.t/0 s with :from and :until fields matching the type of the schedule's start time Examples # using a NaiveDateTime iex&gt; start_time = ~N[2017-01-01 06:00:00] ...&gt; schedule = start_time |&gt; new ( ) |&gt; add_recurrence_rule ( :daily , interval : 2 , hours : [ 10 , 14 ] ) ...&gt; schedule |&gt; occurrences ( ) |&gt; Enum . take ( 3 ) [ ~N[2017-01-01 10:00:00] , ~N[2017-01-01 14:00:00] , ~N[2017-01-03 10:00:00] ] # using an alternate start time iex&gt; start_time = ~N[2017-01-01 06:00:00] ...&gt; schedule = start_time |&gt; new ( ) |&gt; add_recurrence_rule ( :daily , interval : 2 , hours : [ 10 , 14 ] ) ...&gt; schedule |&gt; occurrences ( ~N[2017-10-01 06:00:00] ) |&gt; Enum . take ( 3 ) [ ~N[2017-10-02 10:00:00] , ~N[2017-10-02 14:00:00] , ~N[2017-10-04 10:00:00] ] # using a DateTime with a time zone iex&gt; start_time = Timex . to_datetime ( ~N[2017-01-02 10:00:00] , &quot;America/Los_Angeles&quot; ) ...&gt; schedule = start_time |&gt; new ( ) |&gt; add_recurrence_rule ( :daily ) ...&gt; schedule |&gt; occurrences ( ) |&gt; Enum . take ( 3 ) |&gt; Enum . map ( &amp; Timex . format! ( &amp;1 , &quot;{ISO:Extended}&quot; ) ) [ &quot;2017-01-02T10:00:00-08:00&quot; , &quot;2017-01-03T10:00:00-08:00&quot; , &quot;2017-01-04T10:00:00-08:00&quot; ] # using a NaiveDateTime with a duration iex&gt; start_time = ~N[2017-02-01 12:00:00] ...&gt; schedule = start_time |&gt; new ( duration : 3_600 ) |&gt; add_recurrence_rule ( :weekly ) ...&gt; schedule |&gt; occurrences ( ) |&gt; Enum . take ( 3 ) [ % Cocktail.Span { from : ~N[2017-02-01 12:00:00] , until : ~N[2017-02-01 13:00:00] } , % Cocktail.Span { from : ~N[2017-02-08 12:00:00] , until : ~N[2017-02-08 13:00:00] } , % Cocktail.Span { from : ~N[2017-02-15 12:00:00] , until : ~N[2017-02-15 13:00:00] } ]","ref":"Cocktail.Schedule.html#occurrences/2","title":"Cocktail.Schedule.occurrences/2","type":"function"},{"doc":"Builds an iCalendar format string representation of a Cocktail.Schedule.t/0 . see Cocktail.Builder.ICalendar.build/1 for details.","ref":"Cocktail.Schedule.html#to_i_calendar/1","title":"Cocktail.Schedule.to_i_calendar/1","type":"function"},{"doc":"Builds an iCalendar RRULE format string representation of a Cocktail.Schedule.t/0 . see Cocktail.Builder.ICalendar.build_rule/1 for details.","ref":"Cocktail.Schedule.html#to_i_calendar_rrule/1","title":"Cocktail.Schedule.to_i_calendar_rrule/1","type":"function"},{"doc":"Builds a human readable string representation of a Cocktail.Schedule.t/0 . see Cocktail.Builder.String.build/1 for details.","ref":"Cocktail.Schedule.html#to_string/1","title":"Cocktail.Schedule.to_string/1","type":"function"},{"doc":"Struct used to represent a schedule of recurring events. This type should be considered opaque, so its fields shouldn't be modified directly. Instead, use the functions provided in this module to create and manipulate schedules. Fields: :start_time - The schedule's start time :duration - The duration of each occurrence (in seconds)","ref":"Cocktail.Schedule.html#t:t/0","title":"Cocktail.Schedule.t/0","type":"type"},{"doc":"Struct used to represent a span of time. It is composed of the following fields: from: the start time of the span until: the end time of the span When expanding a Cocktail.Schedule.t/0 , if it has a duration it will produce a list of t/0 instead of a list of Cocktail.time/0 .","ref":"Cocktail.Span.html","title":"Cocktail.Span","type":"module"},{"doc":"Uses Timex.compare/2 to determine which span comes first. Compares from first, then, if equal, compares until . Examples iex&gt; span1 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; span2 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; compare ( span1 , span2 ) 0 iex&gt; span1 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; span2 = new ( ~N[2017-01-01 07:00:00] , ~N[2017-01-01 12:00:00] ) ...&gt; compare ( span1 , span2 ) - 1 iex&gt; span1 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; span2 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 07:00:00] ) ...&gt; compare ( span1 , span2 ) 1","ref":"Cocktail.Span.html#compare/2","title":"Cocktail.Span.compare/2","type":"function"},{"doc":"Creates a new t/0 from the given start time and end time. Examples iex&gt; new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) % Cocktail.Span { from : ~N[2017-01-01 06:00:00] , until : ~N[2017-01-01 10:00:00] }","ref":"Cocktail.Span.html#new/2","title":"Cocktail.Span.new/2","type":"function"},{"doc":"Returns an overlap_mode/0 to describe how the first span overlaps the second. Examples iex&gt; span1 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; span2 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; overlap_mode ( span1 , span2 ) :is_equal_to iex&gt; span1 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; span2 = new ( ~N[2017-01-01 07:00:00] , ~N[2017-01-01 09:00:00] ) ...&gt; overlap_mode ( span1 , span2 ) :contains iex&gt; span1 = new ( ~N[2017-01-01 07:00:00] , ~N[2017-01-01 09:00:00] ) ...&gt; span2 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; overlap_mode ( span1 , span2 ) :is_inside iex&gt; span1 = new ( ~N[2017-01-01 06:00:00] , ~N[2017-01-01 07:00:00] ) ...&gt; span2 = new ( ~N[2017-01-01 09:00:00] , ~N[2017-01-01 10:00:00] ) ...&gt; overlap_mode ( span1 , span2 ) :is_before","ref":"Cocktail.Span.html#overlap_mode/2","title":"Cocktail.Span.overlap_mode/2","type":"function"},{"doc":"","ref":"Cocktail.Span.html#t:overlap_mode/0","title":"Cocktail.Span.overlap_mode/0","type":"type"},{"doc":"","ref":"Cocktail.Span.html#t:span_compat/0","title":"Cocktail.Span.span_compat/0","type":"type"},{"doc":"","ref":"Cocktail.Span.html#t:t/0","title":"Cocktail.Span.t/0","type":"type"},{"doc":"Cocktail Cocktail is an Elixir date recurrence library based on iCalendar events . Its primary use case currently is to expand schedules with recurrence rules into streams of occurrences. For example: say you wanted to represent a repeating schedule of events that occurred every other week, on Mondays, Wednesdays and Fridays, at 10am and 4pm. iex&gt; schedule = Cocktail.Schedule . new ( ~N[2017-01-02 10:00:00] ) ...&gt; schedule = Cocktail.Schedule . add_recurrence_rule ( schedule , :weekly , interval : 2 , days : [ :monday , :wednesday , :friday ] , hours : [ 10 , 16 ] ) # Cocktail.Schedule &lt; Every 2 weeks on Mondays , Wednesdays and Fridays on the 10 th and 16 th hours of the day &gt; Then to get a list of the first 10 occurrences of this schedule, you would do: ...&gt; stream = Cocktail.Schedule . occurrences ( schedule ) ...&gt; Enum . take ( stream , 10 ) [ ~N[2017-01-02 10:00:00] , ~N[2017-01-02 16:00:00] , ~N[2017-01-04 10:00:00] , ~N[2017-01-04 16:00:00] , ~N[2017-01-06 10:00:00] , ~N[2017-01-06 16:00:00] , ~N[2017-01-16 10:00:00] , ~N[2017-01-16 16:00:00] , ~N[2017-01-18 10:00:00] , ~N[2017-01-18 16:00:00] ]","ref":"readme.html","title":"Cocktail","type":"extras"},{"doc":"Cocktail is available in Hex and can be installed by adding cocktail to your list of dependencies in mix.exs : def deps do [ { :cocktail , &quot;~&gt; 0.10&quot; } ] end","ref":"readme.html#installation","title":"Cocktail - Installation","type":"extras"},{"doc":"Detailed documentation with all available options can be found at https://hexdocs.pm/cocktail .","ref":"readme.html#documentation","title":"Cocktail - Documentation","type":"extras"},{"doc":"Schedules Everything starts with a Cocktail.Schedule ; create one like this: iex&gt; schedule = Cocktail . schedule ( start_time , opts ) # Cocktail.Schedule &lt; &gt; # or ...&gt; schedule = Cocktail.Schedule . new ( start_time , opts ) # Cocktail.Schedule &lt; &gt; start_time - Either a DateTime or a NaiveDateTime representing the beginning of your schedule. opts : duration - (optional) How long each occurrence is, in seconds. Recurrence Rules Schedules are pretty useless on their own. To have them do something useful, you add recurrence rules to them. Currently, Cocktail supports: Monthly Weekly Daily Hourly Minutely Secondly On top of these basic recurrence frequencies, you can add various options. Let's see some examples: iex&gt; every_other_day = Cocktail.Schedule . add_recurrence_rule ( schedule , :daily , interval : 2 ) # Cocktail.Schedule &lt; Every 2 days &gt; ...&gt; weekly_on_mo_we_fr = Cocktail.Schedule . add_recurrence_rule ( schedule , :weekly , days : [ :monday , :wednesday , :friday ] ) # Cocktail.Schedule &lt; Weekly on Mondays , Wednesdays and Fridays &gt; ...&gt; daily_at_9am_and_5pm = Cocktail.Schedule . add_recurrence_rule ( schedule , :daily , hours : [ 9 , 17 ] ) # Cocktail.Schedule &lt; Daily on the 9 th and 17 th hours of the day &gt; For more details about frequencies and options, see Cocktail.Schedule.add_recurrence_rule/3 Occurrences Once you've got a schedule set up the way you want, you can generate a stream of occurrences that match the schedule like so: iex&gt; occurrences = Cocktail.Schedule . occurrences ( schedule ) # Function &lt; 60.51599720 / 2 in Stream . unfold / 2 &gt; ...&gt; Enum . take ( occurrences , 3 ) [ ~N[2017-01-01 00:00:00] , ~N[2017-01-02 00:00:00] , ~N[2017-01-03 00:00:00] ] The type of each occurrence depends on what start time type you used, and wether or not you supplied a duration when creating the schedule. Duration If you add the duration option when creating a schedule, you'll get Cocktail.Span structs as occurrences, with :from and :until fields of the same type as your start time. iex&gt; schedule = Cocktail . schedule ( ~N[2017-01-01 00:00:00] , duration : 3600 ) |&gt; Cocktail.Schedule . add_recurrence_rule ( :daily ) # Cocktail.Schedule &lt; Daily &gt; ...&gt; occurrences = Cocktail.Schedule . occurrences ( schedule ) # Function &lt; 60.51599720 / 2 in Stream . unfold / 2 &gt; ...&gt; Enum . take ( occurrences , 3 ) [ % Cocktail.Span { from : ~N[2017-01-01 00:00:00] , until : ~N[2017-01-01 01:00:00] } , % Cocktail.Span { from : ~N[2017-01-02 00:00:00] , until : ~N[2017-01-02 01:00:00] } , % Cocktail.Span { from : ~N[2017-01-03 00:00:00] , until : ~N[2017-01-03 01:00:00] } ] Recurrence Times and Exception Times You can also add one-off recurrence times that don't fit into a normal recurrence pattern, and exception times if you want to exclude a time that would normally be included because of a recurrence rule: iex&gt; schedule = Cocktail . schedule ( ~N[2017-01-01 08:00:00] ) |&gt; Cocktail.Schedule . add_recurrence_rule ( :daily ) # Cocktail.Schedule &lt; Daily &gt; ...&gt; schedule = [ ~N[2017-01-01 09:00:00] , ~N[2017-01-02 11:00:00] , ~N[2017-01-03 17:00:00] ] |&gt; Enum . reduce ( schedule , &amp; Cocktail.Schedule . add_recurrence_time ( &amp;2 , &amp;1 ) ) # Cocktail.Schedule &lt; Daily &gt; ...&gt; schedule = Cocktail.Schedule . add_exception_time ( schedule , ~N[2017-01-02 08:00:00] ) # Cocktail.Schedule &lt; Daily &gt; ...&gt; Cocktail.Schedule . occurrences ( schedule ) |&gt; Enum . take ( 6 ) [ ~N[2017-01-01 08:00:00] , ~N[2017-01-01 09:00:00] , ~N[2017-01-02 11:00:00] , ~N[2017-01-03 08:00:00] , ~N[2017-01-03 17:00:00] , ~N[2017-01-04 08:00:00] ] iCalendar You can convert schedules to and from the iCalendar format like this: iex&gt; i_calendar = Cocktail.Schedule . to_i_calendar ( schedule ) &quot;DTSTART:20170101T000000 \\n RRULE:FREQ=DAILY&quot; ...&gt; Cocktail.Schedule . from_i_calendar ( i_calendar ) { :ok , # Cocktail.Schedule &lt; Daily &gt; }","ref":"readme.html#quick-start-guide","title":"Cocktail - Quick-start Guide","type":"extras"},{"doc":"[ ] investigate and fix DST bugs when using zoned DateTime [ ] support all iCalendar RRULE options [ ] support week-start option [ ] support iCalendar EXRULE [ ] convert to/from JSON representation","ref":"readme.html#roadmap","title":"Cocktail - Roadmap","type":"extras"},{"doc":"Cocktail is heavily inspired by and based on a very similar Ruby library, ice_cube .","ref":"readme.html#credits","title":"Cocktail - Credits","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"Cocktail - License","type":"extras"},{"doc":"MIT License Copyright &amp;copy; 2020 Peek Travel, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"MIT License","type":"extras"}]